#include "fff.h"


#ifndef ENTRY_FUNCTION_DEFINED
#define ENTRY_FUNCTION_DEFINED
typedef void (*entry_function)(void *);
#endif

#include "ucos_ii.h"

FAKE_VALUE_FUNCTION(INT8U, OSEventNameGet, OS_EVENT *, INT8U **, INT8U *)

FAKE_VOID_FUNCTION(OSEventNameSet, OS_EVENT *,\
        INT8U *,\
        INT8U *)

FAKE_VALUE_FUNCTION(INT16U, OSEventPendMulti, OS_EVENT **,\
        OS_EVENT **,\
        void **,\
        INT32U,\
        INT8U *)

FAKE_VALUE_FUNCTION(OS_FLAGS , OSFlagAccept, OS_FLAG_GRP *,\
        OS_FLAGS,\
        INT8U,\
        INT8U *)

FAKE_VALUE_FUNCTION(OS_FLAG_GRP *, OSFlagCreate, OS_FLAGS,\
        INT8U *)

FAKE_VALUE_FUNCTION(OS_FLAG_GRP *, OSFlagDel, OS_FLAG_GRP *,\
        INT8U,\
        INT8U *)

FAKE_VALUE_FUNCTION(INT8U , OSFlagNameGet, OS_FLAG_GRP *,\
        INT8U **,\
        INT8U *)

FAKE_VOID_FUNCTION(OSFlagNameSet, OS_FLAG_GRP *,\
        INT8U *,\
        INT8U *)

FAKE_VALUE_FUNCTION(OS_FLAGS , OSFlagPend, OS_FLAG_GRP *,\
        OS_FLAGS,\
        INT8U,\
        INT32U,\
        INT8U *)

FAKE_VALUE_FUNCTION(OS_FLAGS , OSFlagPendGetFlagsRdy)

FAKE_VALUE_FUNCTION(OS_FLAGS , OSFlagPost, OS_FLAG_GRP *,\
        OS_FLAGS,\
        INT8U,\
        INT8U *)

FAKE_VALUE_FUNCTION(OS_FLAGS , OSFlagQuery, OS_FLAG_GRP *,\
        INT8U *)

FAKE_VALUE_FUNCTION(void *, OSMboxAccept, OS_EVENT *)

FAKE_VALUE_FUNCTION(OS_EVENT *, OSMboxCreate, void *)

FAKE_VALUE_FUNCTION(OS_EVENT *, OSMboxDel, OS_EVENT *,\
        INT8U,\
        INT8U *)

FAKE_VALUE_FUNCTION(void *,OSMboxPend, OS_EVENT *,\
        INT32U,\
        INT8U *)

FAKE_VALUE_FUNCTION(INT8U , OSMboxPendAbort, OS_EVENT *,\
        INT8U,\
        INT8U *)

FAKE_VALUE_FUNCTION(INT8U , OSMboxPost, OS_EVENT *,\
        void *)

FAKE_VALUE_FUNCTION(INT8U , OSMboxPostOpt, OS_EVENT *,\
        void *,\
        INT8U)

FAKE_VALUE_FUNCTION(INT8U , OSMboxQuery, OS_EVENT *,\
        OS_MBOX_DATA *)

FAKE_VALUE_FUNCTION(OS_MEM *, OSMemCreate, void *,\
        INT32U,\
        INT32U,\
        INT8U *)

FAKE_VALUE_FUNCTION(void *,OSMemGet, OS_MEM *,\
        INT8U *)

FAKE_VALUE_FUNCTION(INT8U , OSMemNameGet, OS_MEM *,\
        INT8U **,\
        INT8U *)

FAKE_VOID_FUNCTION(OSMemNameSet, OS_MEM *,\
        INT8U *,\
        INT8U *)

FAKE_VALUE_FUNCTION(INT8U , OSMemPut, OS_MEM *,\
        void *)

FAKE_VALUE_FUNCTION(INT8U , OSMemQuery, OS_MEM *,\
        OS_MEM_DATA *)

FAKE_VALUE_FUNCTION(BOOLEAN , OSMutexAccept, OS_EVENT *,\
        INT8U *)

FAKE_VALUE_FUNCTION(OS_EVENT *, OSMutexCreate, INT8U,\
        INT8U *)

FAKE_VALUE_FUNCTION(OS_EVENT *, OSMutexDel, OS_EVENT *,\
        INT8U,\
        INT8U *)

FAKE_VOID_FUNCTION(OSMutexPend, OS_EVENT *,\
        INT32U,\
        INT8U *)

FAKE_VALUE_FUNCTION(INT8U , OSMutexPost, OS_EVENT *)

FAKE_VALUE_FUNCTION(INT8U , OSMutexQuery, OS_EVENT *,\
        OS_MUTEX_DATA *)

FAKE_VALUE_FUNCTION(void *,OSQAccept, OS_EVENT *,\
        INT8U *)

FAKE_VALUE_FUNCTION(OS_EVENT *, OSQCreate, void **,\
        INT16U)

FAKE_VALUE_FUNCTION(OS_EVENT *, OSQDel, OS_EVENT *,\
        INT8U,\
        INT8U *)

FAKE_VALUE_FUNCTION(INT8U , OSQFlush, OS_EVENT *)

FAKE_VALUE_FUNCTION(void *,OSQPend, OS_EVENT *,\
        INT32U,\
        INT8U *)

FAKE_VALUE_FUNCTION(INT8U , OSQPendAbort, OS_EVENT *,\
        INT8U,\
        INT8U *)

FAKE_VALUE_FUNCTION(INT8U , OSQPost, OS_EVENT *,\
        void *)

FAKE_VALUE_FUNCTION(INT8U , OSQPostFront, OS_EVENT *,\
        void *)

FAKE_VALUE_FUNCTION(INT8U , OSQPostOpt, OS_EVENT *,\
        void *,\
        INT8U)

FAKE_VALUE_FUNCTION(INT8U , OSQQuery, OS_EVENT *,\
        OS_Q_DATA *)

FAKE_VALUE_FUNCTION(INT16U , OSSemAccept, OS_EVENT *)

FAKE_VALUE_FUNCTION(OS_EVENT *, OSSemCreate, INT16U)

FAKE_VALUE_FUNCTION(OS_EVENT *, OSSemDel, OS_EVENT *,\
        INT8U,\
        INT8U *)

FAKE_VOID_FUNCTION(OSSemPend, OS_EVENT *,\
        INT32U,\
        INT8U *)

FAKE_VALUE_FUNCTION(INT8U , OSSemPendAbort, OS_EVENT *,\
        INT8U,\
        INT8U *)

FAKE_VALUE_FUNCTION(INT8U , OSSemPost, OS_EVENT *)

FAKE_VALUE_FUNCTION(INT8U , OSSemQuery, OS_EVENT *,\
        OS_SEM_DATA *)

FAKE_VOID_FUNCTION(OSSemSet, OS_EVENT *,\
        INT16U,\
        INT8U *)

FAKE_VALUE_FUNCTION(INT8U , OSTaskChangePrio, INT8U,\
        INT8U)

//look out for this on
FAKE_VALUE_FUNCTION(INT8U, OSTaskCreate, entry_function,\
                        void *,\
                        OS_STK *,\
                        INT8U)

#ifdef todo
FAKE_VALUE_FUNCTION(INT8U , OSTaskCreateExt, entry_function,\
        void *,\
        OS_STK *,\
        INT8U,\
        INT16U,\
        OS_STK *,\
        INT32U,\
        void *,\
        INT16U)
#endif


FAKE_VALUE_FUNCTION(INT8U , OSTaskDel, INT8U)
FAKE_VALUE_FUNCTION(INT8U , OSTaskDelReq, INT8U)

FAKE_VALUE_FUNCTION(INT8U , OSTaskNameGet, INT8U,\
        INT8U **,\
        INT8U *)

FAKE_VOID_FUNCTION(OSTaskNameSet, INT8U,\
        INT8U *,\
        INT8U *)

FAKE_VALUE_FUNCTION(INT8U , OSTaskResume, INT8U)
FAKE_VALUE_FUNCTION(INT8U , OSTaskSuspend, INT8U)

FAKE_VALUE_FUNCTION(INT8U , OSTaskStkChk, INT8U,\
        OS_STK_DATA *)

FAKE_VALUE_FUNCTION(INT8U , OSTaskQuery, INT8U,\
        OS_TCB *)
FAKE_VALUE_FUNCTION(INT32U , OSTaskRegGet, INT8U,\
        INT8U,\
        INT8U *)

FAKE_VOID_FUNCTION(OSTaskRegSet, INT8U,\
        INT8U,\
        INT32U,\
        INT8U *)
FAKE_VOID_FUNCTION(OSTimeDly, INT32U)

FAKE_VALUE_FUNCTION(INT8U , OSTimeDlyHMSM, INT8U,\
        INT8U,\
        INT8U,\
        INT16U)

FAKE_VALUE_FUNCTION(INT8U , OSTimeDlyResume, INT8U)

FAKE_VALUE_FUNCTION(INT32U , OSTimeGet)
FAKE_VOID_FUNCTION(OSTimeSet, INT32U)

FAKE_VOID_FUNCTION(OSTimeTick)

#ifdef todo
FAKE_VALUE_FUNCTION(OS_TMR *, OSTmrCreate, INT32U,\
        INT32U,\
        INT8U,\
        OS_TMR_CALLBACK,\
        void *,\
        INT8U *,\
        INT8U *)

FAKE_VALUE_FUNCTION(BOOLEAN , OSTmrDel, OS_TMR *,\
        INT8U *)

FAKE_VALUE_FUNCTION(INT8U , OSTmrNameGet, OS_TMR *,\
        INT8U **,\
        INT8U *)

FAKE_VALUE_FUNCTION(INT32U , OSTmrRemainGet, OS_TMR *,\
        INT8U *)

FAKE_VALUE_FUNCTION(INT8U , OSTmrStateGet, OS_TMR *,\
        INT8U *)

FAKE_VALUE_FUNCTION(BOOLEAN , OSTmrStart, OS_TMR *,\
        INT8U *)

FAKE_VALUE_FUNCTION(BOOLEAN , OSTmrStop, OS_TMR *,\
        INT8U,\
        void *,\
        INT8U *)
#endif

FAKE_VALUE_FUNCTION(INT8U , OSTmrSignal)

FAKE_VOID_FUNCTION(OSInit)

FAKE_VOID_FUNCTION(OSIntEnter)
FAKE_VOID_FUNCTION(OSIntExit)

FAKE_VOID_FUNCTION(OSSafetyCriticalStart)

FAKE_VOID_FUNCTION(OSSchedLock)
FAKE_VOID_FUNCTION(OSSchedUnlock)

FAKE_VOID_FUNCTION(OSStart)

FAKE_VOID_FUNCTION(OSStatInit)

FAKE_VALUE_FUNCTION(INT16U , OSVersion)

/*$PAGE*/
/*
 *********************************************************************************************************
 *                                          FUNCTION PROTOTYPES
 *                                      (Target Specific Functions)
 *********************************************************************************************************
 */

FAKE_VOID_FUNCTION(OSDebugInit)

FAKE_VOID_FUNCTION(OSInitHookBegin)
FAKE_VOID_FUNCTION(OSInitHookEnd)

FAKE_VOID_FUNCTION(OSTaskCreateHook, OS_TCB *)
FAKE_VOID_FUNCTION(OSTaskDelHook, OS_TCB *)

FAKE_VOID_FUNCTION(OSTaskIdleHook)

FAKE_VOID_FUNCTION(OSTaskReturnHook, OS_TCB *)

FAKE_VOID_FUNCTION(OSTaskStatHook)

FAKE_VALUE_FUNCTION(OS_STK *, OSTaskStkInit, entry_function,\
        void*,\
        OS_STK*,\
        INT16U)

FAKE_VOID_FUNCTION(OSTaskSwHook)

FAKE_VOID_FUNCTION(OSTCBInitHook, OS_TCB*)

FAKE_VOID_FUNCTION(OSTimeTickHook)

/*$PAGE*/
/*
 *********************************************************************************************************
 *                                          FUNCTION PROTOTYPES
 *                                   (Application Specific Functions)
 *********************************************************************************************************
 */

FAKE_VOID_FUNCTION(App_TaskCreateHook, OS_TCB *)
FAKE_VOID_FUNCTION(App_TaskDelHook, OS_TCB *)
FAKE_VOID_FUNCTION(App_TaskIdleHook)

FAKE_VOID_FUNCTION(App_TaskReturnHook, OS_TCB *)

FAKE_VOID_FUNCTION(App_TaskStatHook)

FAKE_VOID_FUNCTION(App_TaskSwHook)

FAKE_VOID_FUNCTION(App_TCBInitHook, OS_TCB *)

FAKE_VOID_FUNCTION(App_TimeTickHook)

FAKE_VOID_FUNCTION(OSStartHighRdy)
FAKE_VOID_FUNCTION(OSIntCtxSw)
FAKE_VOID_FUNCTION(OSCtxSw)
