#ifndef uCosIITestDouble_H_
#define uCosIITestDouble_H_

#include "ucos_ii.h"
//typedef OS_EVENT * (*OSSemCreate_FPointer)(INT16U cnt);
//typedef OS_EVENT * (*OSSemDel_FPointer)(OS_EVENT *pevent, INT8U opt, INT8U *perr);
typedef void (*OSSemPend_FPointer)(OS_EVENT *pevent, INT32U timeout, INT8U *perr);
typedef INT8U (*OSSemPost_FPointer)(OS_EVENT *pevent);

typedef struct FakeOsEvent
{
	OS_EVENT os_event;
	OSSemPend_FPointer oSSemPend;
	OSSemPost_FPointer oSSemPost;
	int OSSemPend_CallCount;
	int OSSemPost_CallCount;
} FakeOsEvent;

int OSSemCreate_GetCallCount(void);
int OSSemDel_GetCallCount(void);
void OSSemCreate_TestDoubleSetup(OSSemPend_FPointer, OSSemPost_FPointer);
//void OSSemCreate_TestDoubleSetup(OSSemCreate_FPointer osSemCreate, OSSemDel_FPointer osSemDel);
void OSSemCreate_TestDoubleTearDown();

#endif /* uCosIITestDouble_H_ */
