/*
*********************************************************************************************************
*                                                uC/CSP
*                                        CHIP SUPPORT PACKAGE
*
*                          (c) Copyright 2004-2010; Micrium, Inc.; Weston, FL               
*
*               All rights reserved.  Protected by international copyright laws.
*
*               uC/CSP is provided in source form to registered licensees ONLY.  It is 
*               illegal to distribute this source code to any third party unless you receive 
*               written permission by an authorized Micrium representative.  Knowledge of 
*               the source code may NOT be used to develop a similar product.
*
*               Please help us continue to provide the Embedded community with the finest 
*               software available.  Your honesty is greatly appreciated.
*
*               You can contact us at www.micrium.com.
*********************************************************************************************************
*/

/*
*********************************************************************************************************
*
*                                          DEVICE DEFINES
*                                      ACTEL SMARTFUSION A2F200
*
* Filename      : csp_dev.h
* Version       : V1.00
* Programmer(s) : FT
*********************************************************************************************************
* Note(s)       :
*********************************************************************************************************
*/


/*
*********************************************************************************************************
*                                               MODULE
*********************************************************************************************************
*/

#ifndef  CSP_DEV_PRESENT
#define  CSP_DEV_PRESENT


/*$PAGE*/
/*
*********************************************************************************************************
*                                            INCLUDE FILES
*********************************************************************************************************
*/


/*
*********************************************************************************************************
*                                               EXTERNS
*********************************************************************************************************
*/

#ifdef   CSP_DEV_MODULE
#define  CSP_DEV_EXT
#else
#define  CSP_DEV_EXT  extern
#endif


/*
*********************************************************************************************************
*                                        DEFAULT CONFIGURATION
*********************************************************************************************************
*/



/*
*********************************************************************************************************
*                                   A2Fx00 FAMILY DEVICE MEMBER DEFINITION
*********************************************************************************************************
*/

#define  CSP_DEV_ID_A2F200
#define  CSP_DEV_NAME                           "A2F200"


/*
*********************************************************************************************************
*                                    A2FF200 MEMORIES SIZE DEFINES
*********************************************************************************************************
*/

#define  CSP_DEV_FLASH_SIZE                 (256u * 1024u)
#define  CSP_DEV_SRAM_SIZE                  ( 64u * 1024u)


/*
*********************************************************************************************************
*                                             MODULE END
*********************************************************************************************************
*/

#endif                                                          /* End of CSP_DEV module include.                       */

