/*
*********************************************************************************************************
*                                              uC/Modbus
*                                       The Embedded Modbus Stack
*
*                          (c) Copyright 2003-2008; Micrium, Inc.; Weston, FL               
*
*               All rights reserved.  Protected by international copyright laws.
*               Knowledge of the source code may NOT be used to develop a similar product.
*               Please help us continue to provide the Embedded community with the finest
*               software available.  Your honesty is greatly appreciated.
*********************************************************************************************************
*/

/*
*********************************************************************************************************
*
*                                            uC/Modbus
*
*                                      Board Support Package
*                                       Atmel AT91SAM9XE (ARM9)
*
* Filename    : mb_bsp.h
* Version     : V2.12
* Programmers : FT
*********************************************************************************************************
*/

#ifndef  __MB_BSP_H__
#define  __MB_BSP_H__


/*
*********************************************************************************************************
*                                               DEFINES
*********************************************************************************************************
*/
                                                                /* ------------------ UART PORT NUMBERS DEFINES ------------ */
#define  MB_BSP_UART_00                        1
#define  MB_BSP_UART_01                        2
#define  MB_BSP_UART_02                        3
#define  MB_BSP_UART_03                        4
#define  MB_BSP_UART_04                        5
#define  MB_BSP_UART_DBG                       6
                                                                /* ------------------- UART COMMUNICATION MODE ------------- */
#define  MB_BSP_UART_RS232_MODE                1                
#define  MB_BSP_UART_RS485_MODE                2
                                                                /* ----------------- TIMER CONFIGURATION. RTU  MODE -------- */
#define  MB_BSP_TMR_0                          1
#define  MB_BSP_TMR_1                          2
#define  MB_BSP_TMR_2                          3
#define  MB_BSP_TMR_3                          4
#define  MB_BSP_TMR_4                          5
#define  MB_BSP_TMR_5                          6


void  MB_CommRxTxISR_3_Handler (void);


#endif
