/*
*********************************************************************************************************
*                                               uC/OS-II
*                                         The Real-Time Kernel
*                                          DEBUGGER CONSTANTS
*
*                                (c) Copyright 2012, Micrium, Weston, FL
*                                          All Rights Reserved
*
*                                           ARM Cortex-M3 Port
*
* File      : OS_DBG.C
* Version   : V2.89
* By        : Jean J. Labrosse
*
* For       : ARMv7M Cortex-M3
* Mode      : Thumb2
* Toolchain : IAR EWARM
*********************************************************************************************************
*/

#include <ucos_ii.h>

/*$PAGE*/
/*
*********************************************************************************************************
*                                       OS DEBUG INITIALIZAZTION
*
* Description: This empty function could be expanded to support a kernel-aware debugger.
*
* Arguments  : none
*
* Returns    : none
*********************************************************************************************************
*/

#if OS_DEBUG_EN > 0u
void  OSDebugInit (void)
{

}
#endif
