#include "CppUTest/TestHarness.h"

extern "C"
{
#include <os_cfg.h>
#include <ucos_ii.h>
#include <uCosII_TestDouble.fff.h>
}

TEST_GROUP(uCosII_TestDouble)
{
    OS_EVENT event;
    INT8U error;

    void setup()
    {
    }
    void teardown()
    {
    }
};

TEST(uCosII_TestDouble, OSSemPend_basics)
{
    OSSemPend(&event, 0, &error);
    LONGS_EQUAL(1, OSSemPend_fake.call_count);
    POINTERS_EQUAL(&event, OSSemPend_fake.arg0_val);
    LONGS_EQUAL(0, OSSemPend_fake.arg1_val);
    POINTERS_EQUAL(&error, OSSemPend_fake.arg2_val);
    POINTERS_EQUAL(&event, OSSemPend_fake.arg0_history[0]);
    LONGS_EQUAL(0, OSSemPend_fake.arg1_history[0]);
}
